// WallPaper.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "WallPaper.h"
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

IActiveDesktop * pActiveDesktop = NULL;
class CComInit
{
public:
    CComInit(void)
    {
        ::CoInitialize( NULL );
    }

    ~CComInit(void)
    {
        ::CoUninitialize();
    }
} ComInit;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

bool Initialize();
bool GetCurrentWallpaper(LPTSTR pszBuffer, DWORD cch);
bool SetCurrentWallpaper(LPCTSTR pszBuffer);
void Destroy();

bool SelectFile(HWND hWnd, LPTSTR pszBuffer, DWORD cch);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WALLPAPER, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (int) msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_WALLPAPER);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_3DFACE+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_WALLPAPER;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	static HWND hWndEdit = NULL;
	static HWND hWndButton = NULL;
	static const UINT uiLabel = 100;
	static const UINT uiEdit = 101;
	static const UINT uiButton = 102;

	switch (message) 
	{
	case WM_CREATE:
		{
			if (!::Initialize())
				return FALSE;

			hWndEdit = ::CreateWindowEx( 0, _T("edit"), NULL,
				WS_CHILD | WS_VISIBLE | WS_BORDER | ES_AUTOHSCROLL, 100, 0, 400, 18, hWnd,
				reinterpret_cast< HMENU > (uiEdit), hInst, NULL );
			if (!hWndEdit)
				return -1;
			hWndButton = ::CreateWindowEx( 0, _T("button"), _T("Change"),
				WS_CHILD | WS_VISIBLE, 510, 0, 50, 20, hWnd,
				reinterpret_cast< HMENU > (uiButton), hInst, NULL );
			if (!hWndButton)
				return -1;
			if (!::CreateWindowEx( 0, _T("static"), _T("Current Wallpaper:"),
				WS_CHILD | WS_VISIBLE, 0, 0, 100, 18, hWnd,
				reinterpret_cast< HMENU > (uiLabel), hInst, NULL ))
				return -1;
			HFONT hfont = GetStockFont( DEFAULT_GUI_FONT );
			::SendMessage( hWndEdit, WM_SETFONT,
				reinterpret_cast< WPARAM > (hfont), 1 );
			::SendMessage( hWndButton, WM_SETFONT,
				reinterpret_cast< WPARAM > (hfont), 1 );
			::SendMessage( ::GetDlgItem( hWnd, uiLabel ),
				WM_SETFONT, reinterpret_cast< WPARAM > (hfont), 1 );

			TCHAR szWallpaper[ MAX_PATH ] = { _T('\0') };
			if (::GetCurrentWallpaper( szWallpaper, MAX_PATH ))
				::SetWindowText( hWndEdit, szWallpaper );
		}
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		case uiButton:
			switch (wmEvent)
			{
			case BN_CLICKED:
				{
					TCHAR szFileName[ MAX_PATH ] = { _T('\0') };
					if (::SelectFile( hWnd, szFileName, MAX_PATH ))
					{
						::SetCurrentWallpaper( szFileName );
						if (::GetCurrentWallpaper( szFileName, MAX_PATH ))
							::SetWindowText( hWndEdit, szFileName );
					}
				}
				break;
			}
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_DESTROY:
		::Destroy();
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

bool Initialize()
{
	if (!pActiveDesktop)
	{
		HRESULT hr = ::CoCreateInstance( CLSID_ActiveDesktop, NULL,
			CLSCTX_INPROC_SERVER, IID_IActiveDesktop,
			reinterpret_cast< void ** > (&pActiveDesktop) );
		return SUCCEEDED(hr);
	}
	else
		return true;
}

void Destroy()
{
	if (pActiveDesktop)
	{
		pActiveDesktop->Release();
		pActiveDesktop = NULL;
	}
}

bool GetCurrentWallpaper(LPTSTR pszBuffer, DWORD cch)
{
	if (!pActiveDesktop && !Initialize())
		return false;

	LPWSTR pwsz = reinterpret_cast< LPWSTR > (::_alloca( cch * sizeof(WCHAR) ));
	HRESULT hr = pActiveDesktop->GetWallpaper( pwsz, cch, 0 );
	if (SUCCEEDED(hr))
	{
		USES_CONVERSION;
		::lstrcpyn( pszBuffer, W2CT( pwsz ), cch );
		return true;
	}
	else
		return false;
}

bool SetCurrentWallpaper(LPCTSTR pszBuffer)
{
	if (!pActiveDesktop && !Initialize())
		return false;

	USES_CONVERSION;
	HRESULT hr = pActiveDesktop->SetWallpaper( T2CW( pszBuffer ), 0 );
	pActiveDesktop->ApplyChanges( AD_APPLY_ALL );
	return SUCCEEDED(hr);
}

bool SelectFile(HWND hWnd, LPTSTR pszBuffer, DWORD cch)
{
	OPENFILENAME ofn = { 0 };
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFilter = _T("Image Files\0*.bmp;*.jpeg;*.jpg;*.gif\0All Files\0*\0");
	ofn.lpstrFile = pszBuffer;
	ofn.nMaxFile = cch;
	ofn.lpstrTitle = _T("Select a file");
	ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_LONGNAMES |
		OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;

	if (::GetOpenFileName( &ofn ))
	{
		return true;
	}
	else
	{
		return false;
	}
}
